Bug 123975 - "Support primary keys" checkbox in Advanced Settings dialog must be tri-state
Summary: "Support primary keys" checkbox in Advanced Settings dialog must be tri-state
Status: VERIFIED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Base (show other bugs)
Version:
(earliest affected)
6.2.1.2 release
Hardware: All All
: medium normal
Assignee: Caolán McNamara
URL:
Whiteboard: target:6.3.0 target:6.2.3
Keywords: regression
Depends on:
Blocks:
 
Reported: 2019-03-09 23:20 UTC by Mike Kaganski
Modified: 2019-03-13 11:48 UTC (History)
3 users (show)

See Also:
Crash report or crash signature:
Regression By:


Attachments
A dummy ODBC connection to test Advanced Settings dialog (2.25 KB, application/vnd.sun.xml.base)
2019-03-09 23:20 UTC, Mike Kaganski
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Mike Kaganski 2019-03-09 23:20:37 UTC
Created attachment 149851 [details]
A dummy ODBC connection to test Advanced Settings dialog

In Edit->Database->Advanced Settings... dialog, Support primary keys checkbox must be a tri-state [1]. In 6.2, it's a simple toggle, which makes it impossible to enable the heuristics described in [1].

The underlying pool item is indeed OptionalBoolItem - see ODbAdminDialog::createItemSet. But the weld::CheckButton never gets initialized as a tri-state control; and even if it would, all its methods disable the tri-state mode, even initially set by set_inconsistent().

Use attached dummy database to test the dialog.

This is regression from welding work; Caolan - could you please look at this?

Version: 6.2.2.1 (x64)
Build ID: fcd633fb1bf21b0a99c9acb3ad6e526437947b01
CPU threads: 12; OS: Windows 10.0; UI render: GL; VCL: win; 
Locale: ru-RU (ru_RU); UI-Language: en-US
Calc: CL

[1] https://help.libreoffice.org/Common/Special_Settings
Comment 1 Caolán McNamara 2019-03-11 11:39:50 UTC
I think there are two problems, one on top of the other.

https://gerrit.libreoffice.org/#/c/69042/1
https://gerrit.libreoffice.org/#/c/69043/1
Comment 2 Commit Notification 2019-03-11 20:00:53 UTC
Caolán McNamara committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/+/d89dc81a63a36d75f13064ae2a321f1d8903bf30%5E%21

Resolves: tdf#123975 support tri-state for PrimaryKey ui

It will be available in 6.3.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 3 Commit Notification 2019-03-11 20:02:21 UTC
Caolán McNamara committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/+/812316f63bc07520c9736af0360c711780fcbf55%5E%21

Related: tdf#123975 I think this needs to be initially unset

It will be available in 6.3.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 4 Caolán McNamara 2019-03-11 21:36:01 UTC
good in master, backports in gerrit
Comment 5 Commit Notification 2019-03-12 17:21:59 UTC
Caolán McNamara committed a patch related to this issue.
It has been pushed to "libreoffice-6-2":

https://git.libreoffice.org/core/+/63e4ca3c2c595336da4070059c59a6792588aa4f%5E%21

Related: tdf#123975 I think this needs to be initially unset

It will be available in 6.2.3.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 6 Commit Notification 2019-03-12 17:22:05 UTC
Caolán McNamara committed a patch related to this issue.
It has been pushed to "libreoffice-6-2":

https://git.libreoffice.org/core/+/cdac6b66bc3cc77dd3e8b06d19f9e05adc8734c3%5E%21

Resolves: tdf#123975 support tri-state for PrimaryKey ui

It will be available in 6.2.3.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 7 Xisco Faulí 2019-03-13 11:48:33 UTC
Verified in

Verified in

Version: 6.3.0.0.alpha0+
Build ID: 8aa579830b20072af8d6e149d6b279362fe98b91
CPU threads: 4; OS: Linux 4.15; UI render: default; VCL: gtk3; 
Locale: ca-ES (ca_ES.UTF-8); UI-Language: en-US
Calc: threaded

@Caolán, thanks for fixing this issue!